Summary:        Distribution compose tool
Name:           pungi
Version:        4.3.8
Release:        3%{?dist}
License:        GPL-2.0-only
URL:            https://pagure.io/pungi
Source0:        https://pagure.io/releases/%{name}/%{name}-%{version}.tar.bz2

BuildRequires:  make
BuildRequires:  createrepo_c git-core lorax
BuildRequires:  python3-pytest python3-mock python3-devel python3-setuptools python3-productmd
BuildRequires:  python3-kobo-rpmlib python3-lxml python3-kickstart python3-rpm python3-dnf
BuildRequires:  python3-multilib python3-six python3-jsonschema python3-libcomps python3-kobo
BuildRequires:  python3-koji python3-PyYAML python3-libmodulemd python3-gobject python3-createrepo_c
BuildRequires:  python3-dogpile-cache python3-parameterized python3-sphinx
Requires:       createrepo_c koji isomd5sum xorriso git libguestfs-tools-c
Requires:       python3-kobo-rpmlib python3-kickstart python3-koji-cli-plugins python3-dnf
Requires:       python3-multilib python3-libcomps python3-koji python3-libmodulemd
Requires:       python3-gobject python3-createrepo_c python3-PyYAML python3-productmd
Requires:       python3-%{name} = %{version}-%{release}

BuildArch:      noarch

%description
Pungi consists of multiple separate executables backed by a common library.

The main entry-point is the pungi-koji script. It loads the compose configuration
and kicks off the process. Composing itself is done in phases. Each phase is
responsible for generating some artifacts on disk and updating the compose
object that is threaded through all the phases.

Pungi itself does not actually do that much. Most of the actual work is delegated
to separate executables. Pungi just makes sure that all the commands are invoked
in the appropriate order and with correct arguments. It also moves the artifacts
to correct locations.

%package utils
Summary:    Utilities for working with finished composes
Requires:   pungi = %{version}-%{release}
Requires:   python3-fedmsg

%description utils
These utilities work with finished composes produced by Pungi. They can be used
for creating unified ISO images, validating config file or sending progress
notification to Fedora Message Bus.

%package -n python3-%{name}
Summary:    Python 3 libraries for pungi

%description -n python3-%{name}
Python library with code for Pungi. This is not a public library and there are
no guarantees about API stability.


%prep
%autosetup

%build
%py3_build
cd doc
make epub     SPHINXBUILD=/usr/bin/sphinx-build-3
make text     SPHINXBUILD=/usr/bin/sphinx-build-3
make man      SPHINXBUILD=/usr/bin/sphinx-build-3
gzip _build/man/pungi.1

%install
%py3_install
install -d %{buildroot}/var/cache/pungi/createrepo_c
install -d %{buildroot}%{_mandir}/man1
install -m 0644 doc/_build/man/pungi.1.gz %{buildroot}%{_mandir}/man1
rm %{buildroot}%{_bindir}/pungi

%check
%pytest

%files
%license COPYING GPL
%doc AUTHORS
%doc doc/_build/epub/Pungi.epub doc/_build/text/*
%{_bindir}/%{name}-koji
%{_bindir}/%{name}-gather
%{_bindir}/comps_filter
%{_bindir}/%{name}-make-ostree
%{_mandir}/man1/pungi.1.gz
%{_datadir}/pungi
/var/cache/pungi
%dir %attr(1777, root, root) /var/cache/pungi/createrepo_c

%files -n python3-%{name}
%{python3_sitelib}/%{name}
%{python3_sitelib}/%{name}-%{version}-py%{python3_version}.egg-info

%files utils
%{python3_sitelib}/%{name}_utils
%{_bindir}/%{name}-create-unified-isos
%{_bindir}/%{name}-config-dump
%{_bindir}/%{name}-config-validate
%{_bindir}/%{name}-fedmsg-notification
%{_bindir}/%{name}-notification-report-progress
%{_bindir}/%{name}-orchestrate
%{_bindir}/%{name}-patch-iso
%{_bindir}/%{name}-compare-depsolving
%{_bindir}/%{name}-wait-for-signed-ostree-handler


%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.3.8-3
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.3.8-2
- Rebuilt for OpenCloudOS Stream 23.09

* Fri May 05 2023 Miaojun Dong <zoedong@tencent.com> - 4.3.8-1
- initial build
